<?php

require_once('../init.php');

function build_simple_query($details)
{
  if ($_POST['value'] == 0)
    $sql = sprintf("DELETE FROM %s WHERE %s = %d AND %s = %d", $details['table'],
		   $details['basecol'], $details['baseval'],
		   $details['refcol'], $_POST['reference']);
  else
    $sql = sprintf("INSERT INTO %s (%s,%s,sys_user,sys_edit) VALUES (%d,%d,'%s',now())", $details['table'],
		   $details['basecol'], $details['refcol'],
		   $details['baseval'], $_POST['reference'],
		   pg_escape_string($_SESSION['sys']['login']));

  return $sql;
}

function build_query($details,$mask)
{
  $where = '';
  $keys = array_keys($mask['list']);
  for ($i=0; $i<count($keys); $i++)
    if (array_key_exists('filter_'.$i, $_POST)) {
      $filter = explode('|', $_POST['filter_'.$i]);
      if (strlen($where)) $where .= ' AND ';
      if ($filter[0] === 'LIKE') $filter[1] = '%'.$filter[1].'%';
      elseif ($filter[0] === 'EQ') $filter[0] = '=';
      $where .= sprintf("%s %s '%s'",
			empty($mask['list'][$keys[$i]]['sql'])?$keys[$i]:$mask['list'][$keys[$i]]['sql'],
			$filter[0], $filter[1]);
    }

  if ($_POST['value'] == 0)
    $sql = sprintf("DELETE FROM %s WHERE %s = %d AND %s IN (SELECT %s FROM %s%s%s)",
		   $details['table'],
		   $details['basecol'], $details['baseval'],
		   $details['refcol'], $details['refid'], 
		   $details['reftable'],
		   array_key_exists('join', $mask) ? ' JOIN ' . join(' JOIN ', $mask['join']) : '',
		   strlen($where) ? ' WHERE ' . $where : '');
  else
    $sql = sprintf("INSERT INTO %s (%s,%s,sys_user,sys_edit) SELECT %s,%s,'%s',now() FROM %s%s%s",
		   $details['table'],
		   $details['basecol'], $details['refcol'],
		   $details['baseval'], $details['refid'],
                   pg_escape_string($_SESSION['sys']['login']),
		   $details['reftable'],
		   array_key_exists('join', $mask) ? ' JOIN ' . join(' JOIN ', $mask['join']) : '',
		   strlen($where) ? ' WHERE ' . $where : '');

  return $sql;
}

if (empty($_POST['table']))
  exit;

connect_db();
if (load_mask(substr($_POST['table'],5)) === false) exit;

$fields = array_keys($mask['list']);
$field = $fields[$_POST['column']];

if (empty($field)) exit;

if (!is_array($mask['list'][$field]['update'])) return;

if (isset($_POST['reference']))
  $sql = build_simple_query($mask['list'][$field]['update']);
else 
  $sql = build_query($mask['list'][$field]['update'],$mask);

$sth = pg_query($sql);

if ($sth === false)
  error_log($sql . ': ' . pg_last_error());

?>
